org.fourthline.cling.transport.spi

## Interface SOAPActionProcessor

- All Known Implementing Classes:
    PullSOAPActionProcessorImpl, RecoveringSOAPActionProcessorImpl, SOAPActionProcessorImpl

      public interface SOAPActionProcessor

  Converts UPnP SOAP messages from/to action invocations.

  The UPnP protocol layer processes local and remote `ActionInvocation` instances. The UPnP transport layer accepts and returns `StreamRequestMessage`s and `StreamResponseMessage`s. This processor is an adapter between the two layers, reading and writing SOAP content.

  Author:
    Christian Bauer

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `readBody(ActionRequestMessage requestMessage, ActionInvocation actionInvocation)` Converts SOAP XML content of the request message and sets input argument values on the given invocation.
    `void` | `readBody(ActionResponseMessage responseMsg, ActionInvocation actionInvocation)` Converts SOAP XML content of the response message and sets output argument values on the given invocation.
    `void` | `writeBody(ActionRequestMessage requestMessage, ActionInvocation actionInvocation)` Converts the given invocation input into SOAP XML content, setting on the given request message.
    `void` | `writeBody(ActionResponseMessage responseMessage, ActionInvocation actionInvocation)` Converts the given invocation output into SOAP XML content, setting on the given response message.

- - ### Method Detail

    - #### writeBody

          void writeBody(ActionRequestMessage requestMessage,
                         ActionInvocation actionInvocation)
                  throws UnsupportedDataException

      Converts the given invocation input into SOAP XML content, setting on the given request message.
      Parameters:
        `requestMessage` - The request message on which the SOAP content is set.
        `actionInvocation` - The action invocation from which input argument values are read.
      Throws:
        `UnsupportedDataException`

    - #### writeBody

          void writeBody(ActionResponseMessage responseMessage,
                         ActionInvocation actionInvocation)
                  throws UnsupportedDataException

      Converts the given invocation output into SOAP XML content, setting on the given response message.
      Parameters:
        `responseMessage` - The response message on which the SOAP content is set.
        `actionInvocation` - The action invocation from which output argument values are read.
      Throws:
        `UnsupportedDataException`

    - #### readBody

          void readBody(ActionRequestMessage requestMessage,
                        ActionInvocation actionInvocation)
                 throws UnsupportedDataException

      Converts SOAP XML content of the request message and sets input argument values on the given invocation.
      Parameters:
        `requestMessage` - The request message from which SOAP content is read.
        `actionInvocation` - The action invocation on which input argument values are set.
      Throws:
        `UnsupportedDataException`

    - #### readBody

          void readBody(ActionResponseMessage responseMsg,
                        ActionInvocation actionInvocation)
                 throws UnsupportedDataException

      Converts SOAP XML content of the response message and sets output argument values on the given invocation.
      Parameters:
        `responseMsg` - The response message from which SOAP content is read.
        `actionInvocation` - The action invocation on which output argument values are set.
      Throws:
        `UnsupportedDataException`

Copyright © 2016 4th Line GmbH, Switzerland. All rights reserved.